*+
*+
*+    Source Module => CLAVE.PRG
*+
*+    Functions: Function Clavel()
*+               Function DoneBeep()
*+               Function ErrorBeep()
*+
*+    Reformatted by Click! 1.13b3 on May-25-1998 at  2:46 pm
*+
*+

//  Programa	: Clave.prg
//
//  Autor       : Ivn Eduardo Figuera Orantes  e-mail: procom@mailexcite.com
//
//  Descripcin	: Ingreso de Clave mostrando un asterisco (*)
// 		  en lugar de la letra o caracter ASCII (rango: ASCII >=32 hasta ASCII=255
// 		  adems de mostrar una simpatica cara como la de Blinker (puede eliminarse
// 		  para ahorrar espacio en el programa, ya que esto es lo que lo hace grande)
//
//  Utilizacin	: Clavel(texto de ingreso,clave a verificar)
//
//  Ejemplo	: _Check=Clavel('Ingrese clave de acceso','123456')
//                If _Check &&Se ingreso 123456
// 		    ? Clave aceptada
//                Else && No se Ingreso 123456
// 		    ? Clave incorrecta
//                EndIf
//
//  Optimizar	: Se puede agregar como parametros adicionales la ubicacin
// 		  de despliegue de pregunta e ingreso de clave.
//
//  Nota        : La optimizacin no la he realizado por que no tengo aplicacin
// 		  por el momento que la necesite.
//  Observacin	: Este programa no est garantizado que sea infalible, fu desarollado
// 		  por solicitud en el lugar de utlizacin, no se realiz ninguna investigacin
// 		  adicional para mejorarlo, por lo tanto queda a discrecin del programador
// 		  que lo desee utilizar "como esta" (es FREEWARE el cdigo)

clear

_Check := Clavel( 'Password :', '123456' )

if _Check
   ? Password Accepted
else
   ? Password Denied
endif

return

*+
*+
*+    Function Clavel()
*+
*+    Called from ( clave.prg    )   1 - 
*+
*+
*+
function Clavel

private Texto1
private Texto2
private yy
private LTexto1
private LTexto2
private ClColor
private Pasado
private Signo
private QClave
private Ik
private BadC
private xx

parameters Texto1, Texto2

if pcount() < 2 .or. pcount() = 0
   release Texto1, Texto2, yy, LTexto1, LTexto2, ClColor, Pasado, Signo, QClave, Ik, BadC, xx
   return .F.
endif

save screen to Pan_Clvl

Texto1  := alltrim( Texto1 )
Texto2  := upper( Texto2 )
LTexto1 := len( Texto1 )
LTexto2 := len( Texto2 )
ClColor := setcolor()
xx      := LTexto1 + 6

if xx + LTexto2 > 78                    //Limitacin de textos
   Pasado  := xx + LTexto2 - 78
   Texto1  := substr( Texto1, 1, LTexto1 - Pasado )
   LTexto1 := len( Texto1 )
   xx      := LTexto1 + 6
endif

yy := xx

set color to W+/W
@ 22, 00 clear
@ 23, 05 say Texto1         

QClave := ''

set color to GR+/W

set cursor Off
@ 22, 01 say '_ _'           
@ 23, 00 say '(j)'         

set cursor on
@ 23, yy say ''         

Signo := 1

do while .T.
   Ik := inkey( .5 )
   do while Ik = 0
      set cursor Off
      if Signo = 1 .or. Signo = 3 .or. Signo = 5
         @ 22, 01 say '_ _'         
         @ 23, 01 say 'j'         
      elseif Signo = 2
         @ 22, 01 say '  _'         
         @ 23, 01 say '-j'         
      elseif Signo = 4
         @ 22, 01 say '_  '         
         @ 23, 01 say 'j-'         
      else
         @ 22, 01 say '   '         
         @ 23, 01 say '-j-'         
      endif
      set cursor on
      @ 23, yy say ''         
      Signo ++
      if Signo > 6
         Signo := 1
      endif
      Ik := inkey( .5 )                 //Intervalo de tiempo del movimiento de los ojos
   enddo
   @ 23, yy say ''         
   if Ik = 13 .or. Ik = 27              // Teminacin de la funcin
      exit
   endif
   if Ik = 4 .or. Ik = 5 .or. Ik = 24 .or. Ik < 8 .or. Ik > 8 .and. Ik < 32     //Discriminacin de teclas
      loop
   endif
   if Ik = 8 .or. Ik = 19               //Eliminacin de caracteres
      if yy > xx
         QClave := substr( QClave, 1, len( QClave ) - 1 )
         yy --
      endif
      @ 23, yy say ' '         
      @ 23, yy say ''          
      loop
   endif
   if len( QClave ) = LTexto2
      ErrorBeep()
      loop
   endif
   QClave += upper( chr( Ik ) )
   @ 23, yy say '*' // Despliegue de *         
   yy ++
enddo
@ 22, 00 clear
setcolor( ClColor )
Restore screen from Pan_Clvl
release Pan_Clvl
BadC := .F.
if Ik = 27
   BadC := .T.
endif
if QClave <> Texto2
   BadC := .T.
endif
//  Salida de ;a funcin
if BadC
   release Texto1, Texto2, yy, LTexto1, LTexto2, ClColor, Pasado, Signo, QClave, Ik, BadC, xx
   ErrorBeep()
   return .F.
endif

release Texto1, Texto2, yy, LTexto1, LTexto2, ClColor, Pasado, Signo, QClave, Ik, BadC, xx

DoneBeep()

return .T.

*+
*+
*+    Function DoneBeep()
*+
*+    Called from ( clave.prg    )   1 - function clavel()
*+
*+
*+
function DoneBeep

private Warp

parameters Warp

if pcount() < 1
   Warp := 20
endif

tone( warp * 150, 04 )
tone( warp * 130, 05 )

return .T.

*+
*+
*+    Function ErrorBeep()
*+
*+    Called from ( clave.prg    )   2 - function clavel()
*+
*+
*+
function ErrorBeep

tone( 300, 1 )
tone( 499, 5 )
tone( 700, 5 )

return .T.

*+ EOF: CLAVE.PRG
